#!/bin/bash

case $( uname -a | awk '{ print $1 }' ) in
    Darwin) # although this is deprecated, Mac still use it
        PERM="+111"
        ;;
    # Linux) ;& // Fall through does not support in OS X
    # CYGWIN~) ;&
    *)
        PERM="/111"
        ;;
esac
            
function __func_head() {
    echo "Usage:" ${FUNCNAME[1]} $1
}

function __func_help() {
#   echo "Usage:" ${FUNCNAME[1]} $1
    echo "       ${FUNCNAME[1]} $1"
}

# Run through all sources
SDIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"/sources

if [ -d "$SDIR" ]; then
    echo "Begin source:"
    for i in $( find $SDIR -maxdepth 1 -type f -perm $PERM | sort )
    do
        echo "  Source:" $( basename $i )
        . $i
        if [[ $? -ne 0 ]]; then
            echo "    .. failed"
        fi
    done
fi
